
/**3
Schreiben bzw. vervollständigen Sie bitte gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile.
Die erfolgreiche Ausführung der Testfälle in 'main' stellt nicht sicher, dass die Lösung korrekt ist.
*/

public class PraxisAufgabe {

    /*
    Aufgabe: Klassen und Objekte, rekursive Datenstrukturen.

        Ergänzen Sie bitte fehlende Teile der Klassen 'Polynom' und 'Monom' entsprechend den Kommentaren
        an den mit TODO gekennzeichneten Stellen.

    Punkte (in Summe maximal 75):

        20 Punkte in Summe für die Klasse 'Monom'. (Monome sind Bestandteile eines Polynoms, siehe unten.)

        55 Punkte in Summe für die Klasse 'Polynom', aufgeteilt wie folgt:

            40 Punkte für die Implementierung eines binären Suchbaums zum
            Speichern der Monome.

            15 Punkte für die korrekte Funktionalität (unabhängig von der Implementierung).

            Hinweis: Wird statt einer eigenen Implementierung des binären Suchbaums eine vorgefertigte
            Java Collection Klasse oder ein Array genutzt, können für die Klasse 'Polynom'
            maximal 15 Punkte erreicht werden.

    Auch für teilweise korrekte Lösungen werden Punkte vergeben.

    */

    // 'main' ist zum Testen verwendbar und kann beliebig geändert werden.
    // Das Testen wird nicht beurteilt.
    public static void main(String[] args) {
        Polynom p = new Polynom(new int[] {2,0,3,1});

        System.out.println(p); // 2*x^0+3*x^2+1*x^3
        System.out.println(p.eval(1.0)); // 6.0
        System.out.println(p.eval(-2.5)); // 5.125

        Monom m = new Monom(-4,2);

        System.out.println(m); // -4*x^2
        System.out.println(m.eval(1.0)); // -4.0
        System.out.println(m.eval(-2.5)); // -25.0

        p.add(-4,2);

        System.out.println(p); // 2*x^0-1*x^2+1*x^3
        System.out.println(p.eval(1.0)); // 2.0
        System.out.println(p.eval(-2.5)); // -19.875

    }
}

// Die Klasse 'Monom' repräsentiert ein Monom der Form a*x^d (a mal x hoch d), wobei 'a' der Koeffizient,
// 'd' der Grad und 'x' die Unbekannte des Monoms ist. Hinweis: Die Unbekannte 'x' muss nicht gespeichert werden.
class Monom {

    //TODO: Variablen deklarieren
    private int coeff; //a
    private int degree; //d

    // Der Konstruktor mit Parametern für Koeffizienten 'coeff' und Grad des Monoms 'degree'.
    public Monom(int coeff, int degree) {
        //TODO: Konstruktor vervollständigen
        this.coeff = coeff;
        this.degree = degree;
    }

    // Dieser Konstruktor initialisiert das Monom mit Koeffizienten und Grad von 'm'.
    public Monom(Monom m) {
        //TODO: Konstruktor vervollständigen
        this(m.coeff, m.degree);
    }

    // Addiert das angegebene Monom 'm' zu diesem Monom, sofern beide Monome denselben
    // Grad haben. In diesem Fall bekommt dieses Monom einen neuen Koeffizienten, der
    // der Summe der beiden Koeffizienten entspricht und die Methode liefert 'true'.
    // Falls dieses Monom einen anderen Grad hat als 'm', hat die Methode keinen Effekt
    // und liefert 'false'.
    public boolean combine(Monom m) {
        //TODO: Methode vervollständigen
        if(this.degree == m.degree) {
            this.coeff += m.coeff;
            return true;
        }

        return false;
    }

    // Liefert 'true', wenn das Monom einen kleineren Grad als das angegebene Monom 'm' hat, sonst 'false'.
    public boolean lowerDegreeThan(Monom m) {
        //TODO: Methode vervollständigen
        return this.degree < m.degree;
    }

    // Gibt den Wert des Monoms (a*x^d) für den gegebenen Wert von 'x' zurück.
    // Z.B. liefert new Monom(3,2).eval(2) den Wert 12.
    public double eval(double x) {
        //TODO: Methode vervollständigen
        return (double) this.coeff * (Math.pow(x, this.degree));
    }

    // Liefert eine lesbare Repräsentation, in der Form a*x^d, z.B. 5*x^2.
    public String toString() {
        //TODO: Methode vervollständigen
        return this.coeff + "*x^" + this.degree;
    }


    public int getCoeff() {
        return coeff;
    }

    public int getDegree() {
        return degree;
    }
}

// # 20 von 20 Monom korrekt

// Die Klasse 'Polynom' repräsentiert eine Summe von beliebig vielen Monomen unterschiedlichen Grades.
// Beispiel: 5*x^0 +3*x^3 -10*x^7
// 'Polynom' verwendet einen binären Suchbaum zum Speichern von Monomen. Der Grad der Monome ist
// das Suchkriterium. Ein Polynom enthält ein Monom eines bestimmten Grades maximal einmal.
// Es wird davon ausgegangen, dass jedes Objekt vom Typ 'Monom' die gleiche Unbekannte hat ('x').
class Polynom {

    //TODO: Variablen deklarieren
    private TreeNode root; //root Knoten

    // Initialisiert das Polynom mit mehreren Monomen. Die Koeffizienten werden mittels
    // 'coeffs' angegeben, wobei coeffs[i] den Koeffizienten für das Monom vom Grad i enthält.
    // Einträge mit Wert 0 werden ignoriert (nicht gespeichert).
    public Polynom(int[] coeffs) {
        //TODO: Methode vervollständigen
        this.root = new TreeNode(new Monom(coeffs[0], 0));

        for (int i = 1; i < coeffs.length; i++) {
            if(coeffs[i] != 0) {
                root.add(new Monom(coeffs[i], i));
            }
        }

    }

    // Addiert das durch Koeffizienten 'coeff' und Grad 'degree' angegebene Monom zum Polynom,
    // sofern gilt: coeff != 0. Sonst hat die Methode keinen Effekt. Für das Addieren eines Monoms gilt:
    // Falls im Polynom bereits ein Monom mit demselben Grad vorhanden ist,
    // wird dessen Koeffizient entsprechend erhöht (Summe). In diesem Fall wird kein neues Monom
    // gespeichert.
    public void add(int coeff, int degree) {
        //TODO: Methode vervollständigen. Sie können Methoden von 'Monom' nutzen.
        if(coeff != 0) {
            Monom search = new Monom(coeff, degree);
            Monom found = root.search(search); //suche nach monom

            if(found != null) {
                found.combine(search); //addiere monom
            }

        }
    }

    // Gibt den Wert des Polynoms für den gegebenen Wert von 'x' zurück.
    // Die Methode liefert 0, wenn das Polynom keine Monome enthält.
    public double eval(double x) {
        //TODO: Methode vervollständigen
        if(root == null) {
            return 0; //keine monome vorhanden
        }

        return addInorder(root, x, 0d);
    }

    // Liefert eine lesbare Repräsentation dieses Polynoms, in der Form a1*x^d1+a2*x^d2+ ...,
    // z.B. 5*x^0+3*x^3-10*x^7, wobei Monome nach ihrem Grad aufsteigend sortiert sind.
    // Die Methode liefert "0", wenn das Polynom keine Monome enthält.
    public String toString() {
        //TODO: Methode vervollständigen
        if(root == null) {
            return "0";
        }

        return traverseInorder(root);
    }

    public double addInorder(TreeNode node, double x, double erg) {
        if(node == null) {
            return 0;
        }
        erg = node.getVal().eval(x);

        if(node.getLeft() != null) {
            erg += addInorder(node.getLeft(), x, erg);
        }

        if(node.getRight() != null) {
            erg += addInorder(node.getRight(), x, erg);
        }

        return erg;
    }

    public String traverseInorder(TreeNode node) {
        if(node == null) {
            return "";
        }

        // # -4 falsche Reihenfolge
        // # -2 +- nicht richtig behandelt

        return traverseInorder(node.getLeft()) + node.getVal() + traverseInorder(node.getRight());
    }


    //TODO: Binären Suchbaum implementieren (entweder in Polynom oder außerhalb).
    //TODO: Dieser binäre Suchbaum soll von Polynom zur Speicherung von Monomen benutzt werden.

}

// # 15 von 15 Polynom teilweise

class TreeNode {
    private Monom val;
    private TreeNode left, right;

    public TreeNode(Monom val) {
        this.val = val;
    }

    public TreeNode() {

    }

    public void add(Monom m) {
        if(m.lowerDegreeThan(this.val)) { //links einfügen
            if(left != null) {
                left.add(m);
            } else {
                left = new TreeNode(m);
            }
        } else { //rechts einfügen
            if(right != null) {
                right.add(m);
            } else {
                right = new TreeNode(m);
            }
        }
    }

    public Monom search(Monom m) {
        if(m.lowerDegreeThan(this.val)) { //links einfügen
            if(left != null) {
                if(left.getVal().getDegree() == m.getDegree()) {
                    return left.getVal();
                }
                left.search(m);
            }
        } else { //rechts einfügen
            if(right != null) {
                if(right.getVal().getDegree() == m.getDegree()) {
                    return right.getVal();
                }

                right.search(m);
            }
        }

        return null; //monom not found
    }

    public Monom getVal() {
        return val;
    }

    public void setVal(Monom val) {
        this.val = val;
    }

    public TreeNode getLeft() {
        return left;
    }

    public void setLeft(TreeNode left) {
        this.left = left;
    }

    public TreeNode getRight() {
        return right;
    }

    public void setRight(TreeNode right) {
        this.right = right;
    }
}

// # 40 von 40 Baum okay





